org.jgroups.protocols

## Class UNICAST

- java.lang.Object
- - org.jgroups.stack.Protocol
  - - org.jgroups.protocols.UNICAST

All Implemented Interfaces:
  AckSenderWindow.RetransmitCommand, AgeOutCache.Handler<Address>

    public class UNICAST
    extends Protocol
    implements AckSenderWindow.RetransmitCommand, AgeOutCache.Handler<Address>

Reliable unicast layer. Uses acknowledgement scheme similar to TCP to provide lossless transmission of unicast messages (for reliable multicast see NAKACK layer). When a message is sent to a peer for the first time, we add the pair <peer_addr, Entry> to the hashtable (peer address is the key). All messages sent to that peer will be added to hashtable.peer_addr.sent_msgs. When we receive a message from a peer for the first time, another entry will be created and added to the hashtable (unless already existing). Msgs will then be added to hashtable.peer_addr.received_msgs.

This layer is used to reliably transmit point-to-point messages, that is, either messages sent to a single receiver (vs. messages multicast to a group) or for example replies to a multicast message. The sender uses an `AckSenderWindow` which retransmits messages for which it hasn't received an ACK, the receiver uses `AckReceiverWindow` which keeps track of the lowest seqno received so far, and keeps messages in order.

Messages in both AckSenderWindows and AckReceiverWindows will be removed. A message will be removed from AckSenderWindow when an ACK has been received for it and messages will be removed from AckReceiverWindow whenever a message is received: the new message is added and then we try to remove as many messages as possible (until we stop at a gap, or there are no more messages).

Author:
  Bela Ban

### Nested Class Summary

Nested Classes
`static class` `UNICAST.UnicastHeader` The following types and fields are serialized:

### Field Summary

Fields
`static long` `DEFAULT_FIRST_SEQNO`
`protected long` `max_retransmit_time`

### Fields inherited from class org.jgroups.stack.Protocol

`down_prot, ergonomics, id, log, name, stack, stats, up_prot`

### Constructor Summary

Constructors
Constructor and Description
`UNICAST()`

### Method Summary

Methods
`java.lang.Object` `down(Event evt)` An event is to be sent down the stack.
`java.util.Map<java.lang.String,java.lang.Object>` `dumpStats()`
`void` `expired(Address key)` Called by AgeOutCache, to removed expired connections
`AgeOutCache<Address>` `getAgeOutCache()`
`int` `getAgeOutCacheSize()`
`java.lang.String` `getLocalAddress()`
`long` `getMaxRetransmitTime()`
`java.lang.String` `getMembers()`
`long` `getNumAcksReceived()`
`long` `getNumAcksSent()`
`int` `getNumberOfMessagesInReceiveWindows()`
`long` `getNumberOfRetransmissions()`
`int` `getNumberOfUnackedMessages()` The number of messages in all Entry.sent_msgs tables (haven't received an ACK yet)
`long` `getNumBytesReceived()`
`long` `getNumBytesSent()`
`long` `getNumMessagesReceived()`
`long` `getNumMessagesSent()`
`long[]` `getTimeout()`
`static int` `getUndeliveredMessages()` Deprecated.
`java.lang.String` `printAgeOutCache()`
`java.lang.String` `printConnections()`
`java.lang.String` `printUnackedMessages()`
`void` `removeAllConnections()` This method is public only so it can be invoked by unit testing, but should not otherwise be used !
`void` `removeConnection(Address mbr)` Removes and resets from connection table (which is already locked).
`void` `resetStats()`
`void` `retransmit(long seqno, Message msg)` Called by AckSenderWindow to resend messages for which no ACK has been received yet
`void` `setMaxMessageBatchSize(int size)`
`void` `setMaxRetransmitTime(long max_retransmit_time)`
`void` `setTimeout(long[] val)`
`void` `start()` This method is called on a `Channel.connect(String)`.
`void` `stop()` This method is called on a `Channel.disconnect()`.
`java.lang.Object` `up(Event evt)` An event was received from the layer below.

### Methods inherited from class org.jgroups.stack.Protocol

`destroy, downThreadEnabled, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, init, isErgonomics, printStats, providedDownServices, providedUpServices, requiredDownServices, requiredUpServices, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, statsEnabled, upThreadEnabled`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### DEFAULT_FIRST_SEQNO

    public static final long DEFAULT_FIRST_SEQNO

See Also:
  Constant Field Values

#### max_retransmit_time

    protected long max_retransmit_time

### Constructor Detail

#### UNICAST

    public UNICAST()

### Method Detail

#### getUndeliveredMessages

    @Deprecated
    public static int getUndeliveredMessages()

Deprecated.

#### getTimeout

    public long[] getTimeout()

#### setTimeout

    public void setTimeout(long[] val)

#### setMaxMessageBatchSize

    public void setMaxMessageBatchSize(int size)

#### getLocalAddress

    public java.lang.String getLocalAddress()

#### getMembers

    public java.lang.String getMembers()

#### printConnections

    public java.lang.String printConnections()

#### getNumMessagesSent

    public long getNumMessagesSent()

#### getNumMessagesReceived

    public long getNumMessagesReceived()

#### getNumBytesSent

    public long getNumBytesSent()

#### getNumBytesReceived

    public long getNumBytesReceived()

#### getNumAcksSent

    public long getNumAcksSent()

#### getNumAcksReceived

    public long getNumAcksReceived()

#### getNumberOfRetransmissions

    public long getNumberOfRetransmissions()

#### getMaxRetransmitTime

    public long getMaxRetransmitTime()

#### setMaxRetransmitTime

    public void setMaxRetransmitTime(long max_retransmit_time)

#### getAgeOutCacheSize

    public int getAgeOutCacheSize()

#### printAgeOutCache

    public java.lang.String printAgeOutCache()

#### getAgeOutCache

    public AgeOutCache<Address> getAgeOutCache()

#### getNumberOfUnackedMessages

    public int getNumberOfUnackedMessages()

The number of messages in all Entry.sent_msgs tables (haven't received an ACK yet)

#### printUnackedMessages

    public java.lang.String printUnackedMessages()

#### getNumberOfMessagesInReceiveWindows

    public int getNumberOfMessagesInReceiveWindows()

#### resetStats

    public void resetStats()

Overrides:
  `resetStats` in class `Protocol`

#### dumpStats

    public java.util.Map<java.lang.String,java.lang.Object> dumpStats()

Overrides:
  `dumpStats` in class `Protocol`

#### start

    public void start()
               throws java.lang.Exception

Description copied from class: `Protocol`
This method is called on a `Channel.connect(String)`. Starts work. Protocols are connected and queues are ready to receive events. Will be called from bottom to top. This call will replace the START and START_OK events.

Overrides:
  `start` in class `Protocol`
Throws:
  `java.lang.Exception` - Thrown if protocol cannot be started successfully. This will cause the ProtocolStack to fail, so `Channel.connect(String)` will throw an exception

#### stop

    public void stop()

Description copied from class: `Protocol`
This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed

Overrides:
  `stop` in class `Protocol`

#### up

    public java.lang.Object up(Event evt)

Description copied from class: `Protocol`
An event was received from the layer below. Usually the current layer will want to examine the event type and - depending on its type - perform some computation (e.g. removing headers from a MSG event type, or updating the internal membership list when receiving a VIEW_CHANGE event). Finally the event is either a) discarded, or b) an event is sent down the stack using `down_prot.down()` or c) the event (or another event) is sent up the stack using `up_prot.up()`.

Overrides:
  `up` in class `Protocol`

#### down

    public java.lang.Object down(Event evt)

Description copied from class: `Protocol`
An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `down_prot.down()`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`.

Overrides:
  `down` in class `Protocol`

#### removeConnection

    public void removeConnection(Address mbr)

Removes and resets from connection table (which is already locked). Returns true if member was found, otherwise false. This method is public only so it can be invoked by unit testing, but should not otherwise be used !

#### removeAllConnections

    public void removeAllConnections()

This method is public only so it can be invoked by unit testing, but should not otherwise be used !

#### retransmit

    public void retransmit(long seqno,
                  Message msg)

Called by AckSenderWindow to resend messages for which no ACK has been received yet

Specified by:
  `retransmit` in interface `AckSenderWindow.RetransmitCommand`

#### expired

    public void expired(Address key)

Called by AgeOutCache, to removed expired connections

Specified by:
  `expired` in interface `AgeOutCache.Handler<Address>`
Parameters:
  `key` -